// 005 u_irp_safe_ServerController
// 28 jan 2008

// -- (C) Felix John COLIBRI 2008
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_irp_safe_ServerController;

interface

uses
  SysUtils, Classes, IWServerControllerBase, IWBaseForm, HTTPApp,
  // For OnNewSession Event
  u_irp_safe_UserSessionUnit, IWApplication, IWAppForm;

type
  TIWServerController = class(TIWServerControllerBase)
    procedure IWServerControllerBaseCloseSession(ASession: TIWApplication);
    procedure IWServerControllerBaseNewSession(ASession: TIWApplication;
      var VMainForm: TIWBaseForm);

  private
    
  public
  end;


  function UserSession: TIWUserSession;
  function IWServerController: TIWServerController;

implementation

{$R *.dfm}

uses
  IWInit, IWGlobal;

function IWServerController: TIWServerController;
begin
  Result := TIWServerController(GServerController);
end;



function UserSession: TIWUserSession;
begin
  Result := TIWUserSession(WebApplication.Data);
end;

procedure TIWServerController.IWServerControllerBaseNewSession(
  ASession: TIWApplication; var VMainForm: TIWBaseForm);
begin
  ASession.Data := TIWUserSession.Create(nil);
end;

    procedure TIWServerController.IWServerControllerBaseCloseSession(
        ASession: TIWApplication);
      const k_path_delimiter= '\';
      var l_output_file_dir: string;
          l_search_record: TSearchRec;
      begin
        l_output_file_dir:= GServerController.FilesDir+ ASession.AppID;

        // -- CleanUp session's files directory
        if FindFirst(l_output_file_dir+ k_path_delimiter+ '*.*', faAnyFile, l_search_record)= 0
          then
            begin
              repeat
                DeleteFile(l_output_file_dir+ k_path_delimiter+ l_search_record.Name);
              until FindNext(l_search_record)<> 0;
              FindClose(l_search_record);
            end;

        RemoveDir(l_output_file_dir);
      end; // IWServerControllerBaseCloseSession


initialization
  TIWServerController.SetServerControllerClass;

end.

