// 005 u_irp_safe_page
// 28 jan 2008

// -- (C) Felix John COLIBRI 2008
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_irp_safe_page;

interface

uses
  Classes, SysUtils, IWAppForm, IWApplication, IWColor, IWTypes, Controls,
  IWVCLBaseControl, IWBaseControl, IWBaseHTMLControl, IWControl, IWGrids,
  IWDBGrids, DB, DBClient, IWCompButton, RpRender, RpRenderPDF, RpBase,
  RpSystem, RpCon, RpConDS, RpDefine, RpRave, IWCompLabel, IWCompListbox;

type
  TIWForm1 = class(TIWAppForm)
    ClientDataSet1: TClientDataSet;
    DataSource1: TDataSource;
    IWDBGrid1: TIWDBGrid;
    RvProject1: TRvProject;
    RvDataSetConnection1: TRvDataSetConnection;
    RvSystem1: TRvSystem;
    RvRenderPDF1: TRvRenderPDF;
    GenerateAndDisplay: TIWButton;
    IWLabel1: TIWLabel;
    IWLabel2: TIWLabel;
    IWListbox1: TIWListbox;
    procedure IWListbox1Click(Sender: TObject);
    procedure GenerateAndDisplayClick(Sender: TObject);
  public
  end;

implementation
  uses SyncObjs
      , u_irp_safe_ServerController
      ;

  {$R *.dfm}


    var // -- critical section to serialize the .PDF generation
        g_c_rave_critical_section: TCriticalSection= Nil;
        g_sort_column: String= '';
        g_report_count: Integer= 0;

    procedure TIWForm1.GenerateAndDisplayClick(Sender: TObject);
      var l_pdf_file_name: string;
          l_session_id_segment: String;

      procedure generate_pdf;
        var l_c_rave_dataset_connection: TRvDataSetConnection;
        begin
          ClientDataSet1.Close;
          ClientDataSet1.IndexFieldNames:= g_sort_column;
          ClientDataSet1.Open;

          RVProject1.ProjectFile:= WebApplication.ApplicationPath+ '..\_data\r_employee.rav';

          with RvSystem1 do
          begin
            DoNativeOutput:= false;
            RenderObject:= RvRenderPDF1;
            OutputFileName:= IWServerController.FilesDir
                + l_session_id_segment+ '\'+ l_pdf_file_name;
          end; // with RvSystem1

          // -- create the user specific path
          ForceDirectories(ExtractFileDir(RvSystem1.OutputFileName));

          // -- enter into the critical section
          g_c_rave_critical_section.Enter;

          // -- create a new RvDataSetConnectoin
          l_c_rave_dataset_connection:= TRvDataSetConnection.Create(self);

          iwLabel1.Caption:= 'not ok';
          try
            l_c_rave_dataset_connection.Name:= 'my_rave_dataset_connection';
            l_c_rave_dataset_connection.DataSet:= ClientDataset1;

            l_c_rave_dataset_connection.Name:= 'dataset_connection_'+ l_session_id_segment;
            l_c_rave_dataset_connection.DataSet:= ClientDataset1;

            RvProject1.ExecuteReport('Report1');

            iwLabel1.Caption:= 'ok';
          finally
            l_c_rave_dataset_connection.Free;
            g_c_rave_critical_section.leave;

            RvSystem1.OutputFileName:= '';

            iwLabel1.Caption:= iwLabel1.Caption+ ' unlocked';
          end; // try/finally
        end; // generate_pdf

      procedure display_pdf;
        var l_pdf_url: String;

            l_popup_page_name: string;
            l_popup_page_options: string;
            l_popup_parameter: String;
        begin
          // NO l_pdf_url:= WebApplication.AppURLBase+ '\files\'+ l_session_id_segment+ '\'+ l_pdf_file_name;
          // l_pdf_url:= WebApplication.AppURLBase+ '/files/'+ 'my_report_3.pdf';
          // l_pdf_url:= WebApplication.AppURLBase+ '/files/xxx/'+ 'my_report_3.pdf';
          l_pdf_url:= WebApplication.AppURLBase+ '/files/'+ l_session_id_segment+ '/'+ l_pdf_file_name;
          IwLabel2.Caption:= l_pdf_url;

          l_popup_page_name:= 'the_report';
          l_popup_page_options:= 'scrollbars=yes,width=500,height=300';
          l_popup_parameter:= 'NewWindow("'
              + l_pdf_url
              + '", "'+ l_popup_page_name
              + '","'+ l_popup_page_options
              + '");';

          AddToInitProc(l_popup_parameter);
        end; // display_pdf

      begin // GenerateAndDisplayClick
        l_session_id_segment:= WebApplication.AppID;

(*
        l_pdf_file_name:= 'safe_report.pdf';
        l_pdf_file_name:= 'safe_report_'+ g_sort_column+ '.pdf';
        l_pdf_file_name:= 'safe_report_'+ g_sort_column+ '_'+ l_session_id_segment+ '.pdf';
*)
        l_pdf_file_name:= 'safe_report_'+ g_sort_column+ '_'+ l_session_id_segment+ '_'+ IntToStr(g_report_count)+ '.pdf';
        Inc(g_report_count);

        generate_pdf;
        display_pdf;
      end; // GenerateAndDisplayClick

    procedure TIWForm1.IWListbox1Click(Sender: TObject);
      begin
        with IwListBox1 do
          case ItemIndex of
(*
            0 : ClientDataSet1.IndexFieldNames:= 'EmpNo';
            1 : ClientDataSet1.IndexFieldNames:= 'LastName';
            2 : ClientDataSet1.IndexFieldNames:= 'PhoneExt';
            else ClientDataSet1.IndexFieldNames:= '';
*)
            0 : g_sort_column:= 'EmpNo';
            1 : g_sort_column:= 'LastName';
            2 : g_sort_column:= 'PhoneExt';
            else g_sort_column:= '';
          end; // case

          ClientDataSet1.IndexFieldNames:= g_sort_column;
      end; // IWListbox1Click

    initialization
      TIWForm1.SetAsMainForm;
      g_c_rave_critical_section:= TCriticalSection.Create;
    finalization
      g_c_rave_critical_section.Free;
    end.




          try
            l_c_cds:= tClientDataset.Create(Nil);
            l_c_cds.FileName:= 'C:\programs\us\db\rave_pdf_intraweb\_data\employee.xml';
            l_c_cds.IndexFieldNames:= g_sort_column;
            l_c_cds.Open;

            l_c_rave_dataset_connection.Name:= 'dataset_connection_'+ l_session_id_segment;
            l_c_rave_dataset_connection.DataSet:= l_c_cds;

            RvProject1.ExecuteReport('Report1');

            iwLabel1.Caption:= 'ok';
          finally
            l_c_rave_dataset_connection.Free;
            g_c_rave_critical_section.leave;

            RvSystem1.OutputFileName:= '';

            iwLabel1.Caption:= iwLabel1.Caption+ ' unlocked';
          end; // try/finally

